
Imports System.Collections.Generic
Imports System.Text

Namespace Generic
    Partial Public Class Deque(Of T)

        ' --------------------------------------------------------------- represents a node in the deque.
        <Serializable()> _
        Private Class Node

            Private m_value As T
            Private m_previous As Node = Nothing
            Private m_next As Node = Nothing

            Public Sub New(ByVal Value As T)
                m_value = Value
            End Sub

            Public ReadOnly Property Value() As T
                Get
                    Return m_value
                End Get
            End Property

            Public Property Previous() As Node
                Get
                    Return m_previous
                End Get
                Set(ByVal _value As Node)
                    m_previous = TryCast(_value, Node)
                End Set
            End Property

            Public Property [Next]() As Node
                Get
                    Return m_next
                End Get
                Set(ByVal _value As Node)
                    m_next = TryCast(_value, Node)
                End Set
            End Property

        End Class

    End Class

End Namespace
